# Game Sale
 
## Description
This project will use data set of game that sale for each game what the platform of that game and which region that sale this game . User can choose to show between sales rate and what type of game that publish for each year.

## Data Sources
My database for this application from https://data.world/sumitrock/video-games-sales
 
## Running the Application
Dependencies
Here's are the list of necessary dependencies that I used in the project.
    -tkinter
    -pandas
    -mathplotlib

You can install these dependencies by this command.

    pip install -r requirements.txt

you can run program in main.py
 
## Design
![UML](img/UML.png)

`VideoGameFacade` class is use for running program and create the menu PageOne PageTwo and Nework_UI

`PageOne`, `PageTwo` class is the UI that collect data `VideoGame` class then show the graph of data in different ways.

`Nework_UI` class is the UI that collect data and plot network graph

`PlotPie` and `PlotBar` class is the class that use for plot graph.

`AllPlatform` is the class that show sale data by the platform .

`NotAllPlatform` is the class that show sale data by the region that is NA, EU, JP, and other.
 
## Design Patterns Used
`state Design Pattern` - The behavior of some objects depends on what state the object is in. <br>

`Observer Design Pattern` - binding some function to the event of the program

`Facade Design Pattern` - Stock control of program
 
## Graph Algorithm Used
Graph problem is to find shortest path between game genre 

the algorithm use to solve prblem is using the breadth-first search algorithm.
 