# Game sales analysis
 
## Description
This application read the video sale data and user can choose to show between sales rate and what type of game that publish for each year.

### The menu
![UML](img/Menu.PNG)

User can choose between sale rate and game genre.

### Sales Rate
![UML](img/page1.PNG)

User can select game and then click plot to plot graph to see amount of sales.

If user select All platform this program will show user amount of that game sale for each platform.

![UML](img/page1-2.PNG)

### Game Genre

User can see the Genre of game that publish in each year by sliding the bar to year that user want.
![UML](img/page2.PNG)

User can save the graph by using save button or s key on keyboard.
![UML](save but.PNG)

 
## Running the Application
### Python version
* Python 3.9 or better
 ### Module
* `pandas`
* `matplotlib`
* `Video_Games_1.csv` file

You need to run in main.py to start the program.

## Design
![UML](img/UML.png)

`App` class this class use for running program and create the menu

`PageOne` and `PageTwo` class is the UI that collect data `VideoGame` class then show the graph of data in different ways.

`PlotPie` and `PlotBar` class is the class that use for plot graph.

`AllPlatform` is the class that show sale data by the platform .

`NotAllPlatform` is the class that show sale data by the region that is NA, EU, JP, and other.

 
## Design Patterns Used
state Design Pattern - The behavior of some objects depends on what state the object is in.

Observer Pattern - binding some function to the event of the program


## Other Information
Learn about design patterns and how to use tkinter, pandas and matplotlib together.
